// In current case not preferred form of editing!
// As of 2-2016 see github.com/o-jasper/page_html

//  Copyright (C) 05-02-2016 Jasper den Ouden.
//
//  This is free software: you can redistribute it and/or modify
//  it under the terms of the Afrero GNU General Public License as published
//  by the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.

// ==UserScript==
// @name        Commands
// @namespace   Jasper
// @description Commands hub
// @include     *
// @include     file://*
// @version     0.0
// @grant       GM_getValue
// @grant       GM_registerMenuCommand
// @grant       GM_xmlhttpRequest
// @grant       GM_openInTab
// @grant       GM_setClipboard
// @grant       GM_addStyle
// ==/UserScript==

{
    var h = "";
// -insert-asset-htm css/userscript/commands.css
h += ":focus{border:0.2em solid black; font-weight:bold}";
h += "";
h += "/* Panel itself. */";
h += "#CommandPanel{";
h += "    border:0.1em solid black;";
h += "    border-radius: 0.3em;";
h += "";
h += "    position:fixed;";
h += "    top:1em;";
h += "    left:1em;";
h += "    padding:2em;";
h += "    background-color:white;";
h += "    z-index:10000000000000;";
h += "}";
h += "/* Bookmark stuff */";
h += "#cmd_bm_uri{ width:100% }";
h += "#cmd_bm_title{ width:100% }";
h += "";
h += "/* Symbol output */";
h += "#cmd_sym_output{ font-size:300%; }";
// -end
// -insert-asset-htm css/style.css
h += ":focus{border:0.2em solid black; font-weight:bold}";
h += "";
h += ".working{color:red;font-weight:bold}";
h += "";
h += ".minor{color:#666; font-size:70%;}";
h += "";
h += ".hour_min{font-weight:bold; font-size:70%; font-family:'Lucida Console'}";
h += "";
h += ".day_change{font-weight:bold}";
h += "";
h += ".time_month{color:gray ; font-size:80%}";
h += ".time_wday{color:gray ; font-size:80%}";
h += ".time_mday{color:gray ; font-size:80%}";
h += "";
h += ".tag{font-weight:bold}";
h += "";
h += "td{padding-bottom:0em}";
h += "tr{padding-bottom:0em}";
h += "";
h += "/* Going round TRs";
h += " (https://stackoverflow.com/questions/670424/border-around-specific-rows-in-a-tablepage_html)";
h += "TODO listview should get the general style..";
h += "*/";
h += "tr.top td { border-top: 0.2em solid black; }";
h += "tr.bottom td { border-bottom: 0.2em solid black; }";
h += "tr.row td:first-child { border-left: 0.2em solid black; }";
h += "tr.row td:last-child { border-right: 0.2em solid black; }";
// -end
// -insert-asset-htm ../ListView/assets/css/ListView.css
h += "#sql{width:95%;}";
h += "";
h += ".tag{ background-color:#DDF; border-radius: 0.6em; border: 0.14em solid #88F;";
h += "      padding:0.1em 0.1em; font-size:80%";
h += "}";
h += "";
h += ".rawval{text-width:bold}";
h += "";
h += ".local_version{ font-size:50%; color:gray }";
h += "";
h += "a.local_version_href{ color:#779 }";
h += "";
// -end
    GM_addStyle(h);
}

// -insert-asset js/common.js
// In current case not preferred form of editing!
// As of 2-2016 see github.com/o-jasper/page_html


function ge(id) { 
    return document.getElementById(id) || { no_result:true };
}
function maybe_ge(el) {
    if( typeof(el) == 'string' ){ return ge(el); } else{ return el; }
}

function prepend_child(to_el, add_el) {
    if(to_el.childNodes[0]) {
        to_el.insertBefore(add_el, to_el.childNodes[0]);
    } else {
        to_el.appendChild(add_el);
    }
}

var hide_buttons = false;
function hide_button(name, yes) {
    var el = maybe_ge(name);
    el.hidden   = hide_buttons && yes;
    el.disabled = yes;
}

function in_viewport(el) {
    var height = window.innerHeight;
    var top    = el.offsetBottom;
    var bottom = el.offsetTop;
    return top > 0 ? top <= height : (bottom > 0 && bottom <= height);
}

function textarea_fitting(te, config) {
    var te = maybe_ge(te);
    te.rows = Math.min(Math.max(te.value.split("\n").length, 0),
                       config.max_rows);
    te.cols = config.cols;
}

// Fits the length constantly.
function textarea_update(te, after_keydown, config) {
    var te = maybe_ge(te);
    textarea_fitting(te, config);

    te.onkeydown = function(ev){
        textarea_fitting(te, config);
        if(after_keydown){ after_keydown(ev); }
    }
}

// Travelling through guis.
function go_graph(to, ev, graph) {
    if( typeof(to) == 'function' ) { to(ev); }
    else if(to) {
        var got = maybe_ge(to);
        if( !got.hidden ){ got.focus(); }
        else{ follow_graph(graph)({target:got, keyCode:ev.keyCode, shiftKey:true}); }
    }
}

function follow_graph(graph) {
    return function(ev) {
        var kc = ev.keyCode, cur = graph[ev.target.id];
        if( kc == 13 ) {
            if( cur.ed && (!cur.sd || ev.shiftKey) ) { go_graph(cur.d, ev, graph); }
        } else if( kc == 40 ) {
            if( !cur.sd || ev.shiftKey ) { go_graph(cur.d, ev, graph); }
        } else if( kc == 38 ) {
            if( !cur.su || ev.shiftKey ) { go_graph(cur.u, ev, graph); }
        } else if( kc == 37 ) {
            if( !cur.sl || ev.shiftKey ) { go_graph(cur.l, ev, graph); }
        } else if( kc == 39 ) {
            if( !cur.sr || ev.shiftKey ) { go_graph(cur.r, ev, graph); }
        }
    }
}

// Making lines around current list selection in tables.
function focus_table_list(el, out, prep) {
    var prep = prep || "";
    // Find the `TR` level.
    if( el.nodeName != '#comment' ) {
        while(el && el.nodeName != 'TR'){ el = el.parentNode; }
    }
    // Find the comment node representing the "the start of the section."
    var prev = el;
    while( el  && el.nodeName != '#comment' ) {
        prev = el;
        el = el.previousSibling;
    }
    el = prev;  // Iterate, applying the classes.
    var first, last;
    while( el && (el.nodeName != '#comment') ) {
        first = first || (el.nodeName == 'TR' && el);
        last  = (el.nodeName == 'TR' && el) || last;

        el.className = (out ? "" : prep + "row");

        el = el.nextSibling;
    }
    if( !out ) {
        first.className += " " + prep + "top";
        last.className  += " " + prep + "bottom";
    }
}


// Basically here because list entries arent handy units.
// (but i kindah want the vertical alignment of tables.)
function list_move(i, name, info, alt_fun) {
    if(name) {
        var funs = info[name] || info;
        var cur = ge(info.nameprep + i + "_" + name);
        if( cur.no_result ){
            (alt_fun || funs.alt_fun || info.alt_fun ||
             function(){ alert("No:" + info.nameprep + i + "_" + name); })();
        } else {
            cur.onfocus = function() {
                cur.hidden = false;
                focus_table_list(cur, false);  // Add the borders.
            }
            cur.onblur = function(){
                cur.hidden = funs.hide_it;
                focus_table_list(cur, true);  // Remove the borders.
            }
            cur.onkeydown = function(ev) {
                var kc = ev.keyCode, order = info.order;
                var ol = order.length;

                if(kc == 38){ list_move(i - 1, name, info, info.limit_u) }
                else if(kc == 40){ list_move(i + 1, name, info, info.limit_d) }
                else if(kc == 37){
                    list_move(i, order[(funs.i - 1 + ol)%ol], info, info.limit_r);
                }
                else if(kc == 39){
                    list_move(i, order[(funs.i + 1)%ol], info, info.limit_l);
                }
            }
            if(info.block_keyup){ cur.onkeyup = function(){} }
            cur.onclick = funs.onclick || null;
            cur.hidden = false;
            cur.focus();
        }
    }
}
// -end
// -insert-asset js/search_common.js
// In current case not preferred form of editing!
// As of 2-2016 see github.com/o-jasper/page_html

// Common stuff about finding stuff in elements.

// Finds something with a href.
function find_a_href(el, also, n) {
    n = n || 5
    also = also || {previousSibling:true, nextSibling:true, }
    if( el.href ){ return el.href; }
    if( n > 0 ) {
        for(var i in el.children){
            var href = find_a_href(el.children[i], also, n-1)
            if( href ){ return href; }
        }
    }
    var href;
    if(also.previousSibling){ href = find_a_href(el.previousElementSibling, {}, n-1); }
    if(href){ return href; }
    if(also.nextSibling){ href = find_a_href(el.nextElementSibling, {}, n-1); }
    return href;
}

// Function returning cursor-distance-to-element. Doesnt work. Why
//  arent there clear coordinate systems...
function element_pos_dist(x,y) {
    return function(el) {
        var ex = el.clientLeft - document.body.clientLeft,
            ey = el.clientTop - document.body.clientTop;
        // Note the weights!
//TODO...
        return Math.sqrt(Math.pow(x - ex, 2) + Math.pow(y - ey, 2));
    }
}

function find_closest_els(dist, search_list, range, allow) {
    if( typeof(dist) != 'function' ) { dist = element_pos_dist(dist[0], dist[1]); }
    var ret = [];
    for( var i in search_list ){ // Unsorted, just in-range.
        var el = search_list[i];
        if( el && dist(el) < range && (!allow || allow(el))) { ret.push(el); }
    }
    ret.sort(dist);
    return ret;
}

function replace_all(str, replacers) {
    for( var k in replacers ) {
        var n = str.replace("{%" + k + "}", replacers[k]);
        while( n != str ){
            str = n;
            n = str.replace("{%" + k + "}", replacers[k]);
        }
    }
    return str;
}

function activated_list(into, list, string_fun, alter_fun) {
    var h = "<table>";
    if( typeof(string_fun) == 'function' ) {
        for(var i in list) { h += string_fun(list[i], parseInt(i)); }
    } else {
        for(var i in list) { list[i].i = i; h += replace_all(string_fun, list[i]); }
    }
    into.innerHTML += h + "</table>";

    if(alter_fun) { // NOTE/TODO `list_move` might be better.
        for(var i in list) {  // Mysteriously it turns into a string fucking me up.
            alter_fun(list[i], parseInt(i));
        }
    }
}
// -end
// -insert-asset js/pegasus_send.js
// In current case not preferred form of editing!
// As of 2-2016 see github.com/o-jasper/page_html

// Send to pegasus, but w/o the pegasus js available.

function pegasus_send(server_url, on_name, data, onload) {
    var path = on_name.split("/")
    var last = path.pop()

    var full_url = server_url + path.join("/") + "/PegasusJs/" + last;
    var send_data = JSON.stringify({d:data});

    GM_xmlhttpRequest({
        method: 'POST',
        url: full_url,
        data: send_data,
        headers: {
            'Content-Type': "application/x-www-form-urlencoded"
        },
        onload: onload
    });
}
// -end
// -insert-source figure_server.js
// In current case not preferred form of editing!
// As of 2-2016 see github.com/o-jasper/page_html

var server_url = GM_getValue('server', "http://localhost:9090/");
function send(on_name, data, onload){ pegasus_send(server_url, on_name, data, onload); }
// -end

// -insert-source list_assist.js
// In current case not preferred form of editing!
// As of 2-2016 see github.com/o-jasper/page_html

// Closest links sorted
function find_cursor_closest_links(limit, got_uri) {
    var know_uri = {}
    if(typeof(got_uri) == 'string') { know_uri[got_uri] = true; }
    else{ for( var k in got_uri ){ know_uri[k] = true; } }

    var list = find_closest_els(
        [iface_state.x, iface_state.y],
        document.getElementsByTagName("A") || document.links,
        (GM_getValue('cmd_vid_range') || 0.2)*window.innerWidth,
        function(el) {
            if(el.href && !know_uri[el.href]) {
                know_uri[el.href] = true; return true;
            }
        });
    // Enforce a limit on number of items.
    var limit = limit || GM_getValue('cmd_vid_limit_cnt') || 6;
    while( list.length > limit ){ list.pop(); }
    return list;
}

// Enter a list of actions, defaultly of links.

function produce_action_list(into, list, html, go_action, before_id, after_id) {
    activated_list(into, list,
                   html || ("<!--{%i}--><tr><td><button id ='cmd_vid_{%i}'>" + 
                            "{%textContent}</button></td><td>" + 
                            "<a href='{%href}'><code>{%href}</code></a></td></tr>"),
                   function(el, j) {
                       var set = ge('cmd_vid_' + j);
                       set.onclick = function(){ go_action(el, j); }
                       set.onkeydown = function(ev) {
                           if( ev.keyCode == 40 ) {
                               ge((after_id && j == list.length-1) ? after_id :
                                  'cmd_vid_' + (j+1)).focus();
                           } else if( ev.keyCode == 38 ){
                               ge((before_id && j == 0) ? before_id :
                                  ('cmd_vid_' + (j - 1))).focus();
                           }
                       }
                       set.onblur = function(ev) {
                           focus_table_list(set, true);
                       }
                       set.onfocus = function(ev){
                           focus_table_list(set); //cur_sel_list_cleanup);
                       }
                   });
}
// -end

var command_element;

function sayit() {
    alert("Submitted:" + command_element.value);
}

var selection, pos_frac;  // Holds selection, as otherwise lost due to focus change.

var iface_state = {}

document.onmouseover = function(ev){
    var el = ge('CommandPanel'), is = iface_state;
    if(!el || el.hidden){
        is.hovered = ev.target;
        is.hovered_href = is.hovered.href || is.hovered_href;
    }

    is.x = ev.clientX - document.body.clientLeft;
	  is.y = ev.clientY - document.body.clientTop;
}
/*
if( (GM_getValue('cmd_track_cursor') || "yes") == "yes" ) {
    var is = iface_state;
    document.onmousemove = function(ev) {
        is.x = ev.pageX;
        is.y = ev.pageY;
    }
} */

function currentPosFraction()
{
    var el = document.documentElement;

    var w = el.scrollHeight;// - el.clientHeight;
    var h = el.scrollWidth; //  - el.clientWidth;

    var x = el.scrollTop;  //  + d.body.scrollTop;
    var y = el.scrollLeft; // + d.body.scrollLeft;

// TODO better to just pass w,h along?
    return [x/w, y/h]
}

// TODO separate each portion.

function toggle_commandpanel(immediate) {
    selection = window.getSelection().toString();
    pos_frac  = currentPosFraction();

    if( command_element ) {
        command_element.hidden = !command_element.hidden;
    } else {
        var document = window.document;

        var element = command_element || document.createElement('div');
        command_element = element;
        element.id = 'CommandPanel'

        // TODO line around, other styling.
        var h = "";
// -insert-asset-htm parts/command_panel.htm
h += "Cmd <input id='command_immediate' type='checkbox'>";
h += "<input id='command_input' onsubmit='sayit();' onkeydown='sayit();'>";
h += "<button onclick='sayit();'>Do</button>";
h += "<span id='command_extend'</span>";
// -end
        element.innerHTML = h;

        document.body.appendChild(element);

        // Run stuff if complete inputs.
        ge('command_input').oninput = function(){
            var ci = ge('command_input');
            // Strip out the command starter.
            ci.value = ci.value.replace(";", "");

            if( ge('command_immediate').checked ) {
                var fun = funs[ci.value];
                if(fun && fun()) {
                    ci.value = "";
                    toggle_commandpanel();
                }
            }
        }
    }
    ge('command_immediate').checked = immediate;
    if( command_element.hidden ) {
        ge('command_input').blur();
        // TODO kindah want to select the thing we left.
    } else {
        ge('command_input').focus();
    }
}

function finish_commandpanel() {
    ge('command_extend').innerHTML = ""; // Clean up.
    ge('command_input').value = "";
    ge('command_input').onkeydown = null;
    toggle_commandpanel(); // Turn off.
}

GM_registerMenuCommand("Command Panel", toggle_commandpanel);

var funs = {};

// -insert-source make_bookmark.js
// In current case not preferred form of editing!
// As of 2-2016 see github.com/o-jasper/page_html

// ---- Bookmarks.
// TODO feel like maybe want bare tag-uri too? (just immediately select the tag?)

function make_bookmark() {
    var h = "";
// -insert-asset-htm parts/make_bookmark.htm
h += "<span style='font-size:150%; text-weight:bold'>Bookmark</span>";
h += "<table>";
h += "  <tr><td>Uri:</td>  <td><input type='text' id='cmd_bm_uri'></td></tr>";
h += "  <tr><td>Title:</td><td><input type='text' id='cmd_bm_title'></td></tr>";
h += "  <tr><td>Text:</td> <td><textarea id='cmd_bm_text'></textarea></td></tr>";
h += "  <tr><td>Quote:</td><td><textarea id='cmd_bm_quote'></textarea></td></tr>";
h += "  <!-- TODO tags enter-to-add-1 and make them buttons-to-remove one. -->";
h += "  <tr><td>Tags</td>  <td><input type='text' id='cmd_bm_tags'>";
h += "      <span id='cmd_bm_taglist'></span></td></tr>";
h += "  <tr><td span=2><button id='cmd_bm_submit'>Submit</button></td></tr>";
h += "</table>";
// -end
    ge('command_extend').innerHTML = h;
    ge('cmd_bm_uri').value   = document.documentURI;
    ge('cmd_bm_quote').value = selection;

    // NOTE: otherwise need to escape stuff.(which would be silly)
    ge('cmd_bm_title').value = document.title;

    var graph = {
        command_input : { d :'cmd_bm_uri' },
        cmd_bm_uri    : { d :'cmd_bm_title', u : 'command_input' },
        cmd_bm_title  : { ed:true, d :'cmd_bm_text', u : 'cmd_bm_uri' },
        cmd_bm_text   : { ed:true, sd:true, d : 'cmd_bm_quote', su:true, u : 'cmd_bm_title' },
        cmd_bm_quote  : { ed:true, sd:true, d : 'cmd_bm_tags',  su:true, u : 'cmd_bm_text' },
        cmd_bm_tags   : {
            d : 'cmd_bm_submit', u:'cmd_bm_quote',
            r : function(){
                var to = ge('cmd_bm_taglist').childNodes[0];
                if(to){ to.focus(); }
            },
            l : function(){
                var children = ge('cmd_bm_taglist').childNodes;
                var to = children[children.length - 1];
                if(to){ to.focus(); }
            }
        },
        cmd_bm_submit : { u : 'cmd_bm_tags' }
    };
    var fg = follow_graph(graph);

    ge('command_input').onkeydown = fg;
    ge('cmd_bm_uri').onkeydown = fg;
    ge('cmd_bm_title').onkeydown = fg;
    var config = { max_rows:20, cols:90 }
    textarea_update('cmd_bm_text',  fg, config);
    textarea_update('cmd_bm_quote', fg, config);

    var cs = ge('cmd_bm_submit');
    cs.onclick = function() {
        var tag_els = ge('cmd_bm_taglist').childNodes;
        var tag_list = [];
        for(var i in tag_els){
            if( tag_els[i].nodeName == 'BUTTON' ){
                tag_list.push(tag_els[i].textContent);
            }
        }
        send('bookmarks/.collect',
             [ge('cmd_bm_uri').value,
              ge('cmd_bm_title').value,
              ge('cmd_bm_text').value,
              ge('cmd_bm_quote').value,
              tag_list, pos_frac]);

        // TODO instead of returning, respond by telling if success?
        finish_commandpanel();
    }

    cs.onkeydown = function(ev) {  // Cycle _inside_ the thing.
        if( ev.keyCode == 9 ){ ge('command_immediate').focus(); }
        else{ fg(ev); }
        // else if( ev.keyCode == 13 ){ cs.onclick(); }  // Already automatically so.
    }

    var ct = ge('cmd_bm_tags');
    ct.onkeydown = function(ev){
        if( ev.keyCode == 13 ) {
            // TODO shift-enter should focus-and-submit, otherwise,
            //  just select the button-to-submit.(currently not so..)
            if( ct.value.length == 0 ){ cs.focus(); return false; }

            // Add a button signifying the tag, clicking removes.
            var button = document.createElement('button');
            button.textContent = ct.value;
            button.onmouseover = function(){  // TODO use CSS hover instead..
                button.style['text-decoration'] = 'line-through';
            }
            button.onmouseout = function(){ button.style['text-decoration'] = null }

            button.onclick = function(){
                var to = button.nextSibling || button.previousSibling;
                if(to){ to.focus(); } else{ ge('cmd_bm_tags').focus(); }
                ge('cmd_bm_taglist').removeChild(button);
            };

            button.onkeydown = function(ev) {
                if( ev.keyCode == 37 ) {
                    (button.previousSibling || ge('cmd_bm_tags')).focus();
                } else if( ev.keyCode == 39 ) {
                    (button.nextSibling || ge('cmd_bm_tags')).focus();
                } else if( ev.keyCode == 40 ) {
                    ge('cmd_bm_submit').focus();
                } else if( ev.keyCode == 38 ) {
                    ge('cmd_bm_quote').focus();
                }
            }

            // We'll just use this as list of tags too.
            ge('cmd_bm_taglist').appendChild(button);
            ct.value = "";
        }
        fg(ev);
    }

    ge('cmd_bm_text').focus();
}
// -end
funs.bm = make_bookmark;

// -insert-source quickmarks.js // TODO
// In current case not preferred form of editing!
// As of 2-2016 see github.com/o-jasper/page_html

// --- Running videos

var cmd_make_quickmark_fun = function(el) {
    //TODO
    send('bookmarks/.make_quickmark',
         [el.href, document.title, ge('cmd_qm_name').value, pos_frac],
         function(){ finish_commandpanel(); });
}

function cmd_make_quickmark() {  // Try open as video.
    ge('command_extend').innerHTML = "working...";

    var is = iface_state;
    var hover_uri = (is.hovered && find_a_href(is.hovered)) || is.hovered_href;
    if( (GM_getValue('cmd_make_quickmark_linklist') || "yes") != "yes" ) {
        cmd_make_quickmark_fun({href:hover_uri || document.documentURI});
    } else {  // NOTE the thing seems not very effective..
        // Get sorted list.
        var list = find_cursor_closest_links(false, hover_uri);

        list.unshift({ textContent:"cur page", href:document.documentURI });
        if(hover_uri){ list.unshift({ textContent:"hovered", href:hover_uri }); }

        ge('command_extend').innerHTML = "<input id='cmd_qm_name' value='default'>";
        produce_action_list(ge('command_extend'), list, null, cmd_make_quickmark_fun,
                            'cmd_qm_name');

        ge('cmd_qm_name').onkeydown = function(ev) {
            if( ev.keyCode == 40 ) {
                ge('cmd_vid_0').focus();
            } else if(ev.keyCode == 38) {
                ge('command_input').focus();
            } else if( ev.keyCode == 13 ) {
                // Enter uses the top one.(hovered or current page)
                cmd_bookmark_fun(list[0]);
            }
        }

        ge('command_input').onkeydown = function(ev) {
            if(ev.keyCode == 40){ ge('cmd_vid_0').focus(); }
        }
        ge('cmd_qm_name').focus();
    }
}

var quickmark_prev_name;
var cmd_go_quickmark_fun = function(name) {
    if( quickmark_prev_name != name && name != "" ) {  // Only if changed.
        quickmark_prev_name = name;
        ge('cmd_qm_list').innerHTML = "getting...";
        send('bookmarks/.get_quickmarks_html', [name],
             function(result_obj) {
                 var html_list = JSON.parse(result_obj.responseText)[0];
                 ge('cmd_qm_list_cnt').innerHTML = html_list.length;
                 var h = "";
                 for(var i in html_list) { h += html_list[i]; }
                 ge('cmd_qm_list').innerHTML = h;
             });
    }
}
// TODO this thing doesnt have the needed classes.
//
// TODO can be improved; button to "open all in tabs",
// selecting a subset, "open selected in tabs", deleting.
//
// HOWEVER, consider what you want in the list functionality in general,
// preferably it transfers to _both_
function cmd_go_quickmark() {
    var h = "Name <input id='cmd_qm_name' value='default'>";
    h += "Got <span id='cmd_qm_list_cnt'>(count)</span>";
    h += "<table id='cmd_qm_list'><tr><td colspan=4>(initial)</td></tr></table>";
    ge('command_extend').innerHTML = h;

    var name_el = ge('cmd_qm_name');
    name_el.focus();

    var d = function() {
        list_move(1, 'linked_title', {
            limit_u:function() { ge('cmd_qm_name').focus(); },
            nameprep:"list_el_",
            mirror:{i:0}, linked_title:{i:1},
            order:["mirror", "linked_title"],
        });
    }

    var graph = { command_input:{ sr:true, r:'cmd_qm_name',   d:'cmd_qm_name' },
                  cmd_qm_name : { sl:true, l:'command_input', u:'command_input',
                                  d:d
                                }
                };
    var fg = follow_graph(graph);
    ge('command_input').onkeydown = fg;
    name_el.onkeydown = fg;

    quickmark_prev_name = null;  // Force re-do.
    cmd_go_quickmark_fun(name_el.value); // Default.
    name_el.onkeyup = function(ev) {
        cmd_go_quickmark_fun(name_el.value);
    }
}
// -end
funs.qm = cmd_make_quickmark;
funs.gqm = cmd_go_quickmark;

// -insert-source cmd_on_string.js
// In current case not preferred form of editing!
// As of 2-2016 see github.com/o-jasper/page_html


function cmd_on_string(fun, button_str, dont_finish) {
    return function() {
        ge('command_extend').innerHTML = "<br><textarea id='cmd_js_code'></textarea>" +
            "<br><button id='cmd_submit'>" + button_str + "</button>";

        var graph = {
            command_input : { d:'cmd_js_code' },
            cmd_js_code   : { su:true, u:'command_input', sd:true, d:'cmd_submit'},
            cmd_submit    : { u:'cmd_js_code' }
        }
        var fg = follow_graph(graph);

        ge('command_input').onkeydown = fg;

        var code_el = ge('cmd_js_code');

        code_el.rows = Math.max(code_el.value.split("\n").length, 0);
        code_el.cols = GM_getValue('reasonable_width', 80);

        var cs = ge('cmd_submit');

        cs.onclick = function() {
            fun(code_el.value);
            if(!dont_finish){ finish_commandpanel(); }
        }
        cs.onkeydown = fg;

        code_el.onkeydown = function(ev) {
            code_el.rows = Math.max(code_el.value.split("\n").length, 0);

            if( ev.keyCode == 13 && ev.shiftKey ) { cs.onclick(); }
            fg(ev);
        }
        code_el.focus();
    }
}
// -end

// --- Javascript/lua evaluation.
if( GM_getValue('cmd_js', false) ) {
    funs.js  = cmd_on_string(function(str){ alert(eval(str)) }, "Run js");
}

// NOTE: doesnt work at this point!
if( GM_getValue('cmd_lua', false) ) {
    funs.lua = cmd_on_string(function(str){
        send('util/.run_lua', [str], function(result_obj) {
            var result = JSON.decode(result_obj.responseText);
            if(result.disallowed) { alert("Disallowed"); }
            else{ alert("Allowed: " + result); }
            finish_commandpanel();
        });
    }, "Run lua(server side, if allowed)", true);
}

if( GM_getValue('cmd_syms', true) ) {
    funs.syms = function() {
        ge('command_extend').innerHTML = "<br><input id='cmd_sym_val'><br><span id='cmd_sym_output'></span>";
        var sym_val = ge('cmd_sym_val');
        sym_val.focus();
        sym_val.onkeydown = function(ev) {
            if( ev.keyCode == 13 ) {
                GM_setClipboard(ge('cmd_sym_output').innerHTML);
                finish_commandpanel();
            }
        }
        sym_val.onkeyup = function(ev) {
            ge('cmd_sym_output').innerHTML = "&" + sym_val.value + ";";
        }
    }
}

// --- Manuals and documentation.
function cmd_opentab(button_str, httpreq) {
    return cmd_on_string(function(str) {
        ge('command_extend').innerHTML += "working...";
        send(httpreq, [str], function(result_obj){
            var result = JSON.parse(result_obj.responseText);
            if( result.length > 0 ){ GM_openInTab(result); }
            finish_commandpanel();
        });
    }, button_str, true);
}

funs.man   = cmd_opentab("View man page",      'util/.man');
funs.doc   = cmd_opentab("View documentation", 'util/.doc');
funs.pydoc = cmd_opentab("View pydoc page",    'util/.pydoc');

// -insert-source cmd_vid.js
// In current case not preferred form of editing!
// As of 2-2016 see github.com/o-jasper/page_html

// --- Running videos

var cmd_vid_fun = function(el) {
    ge('cmd_vid_say').textContent = "working...";
    send('util/.vid', [el.href],
         function(result_obj) {
             var tab = JSON.parse(result_obj.responseText);
             if( tab ) {
                 var on_get_success = function(){
                     var uri = tab.pref_uri || tab.m_uri;
                     if(GM_getValue('new_tab_own_mirror') || uri != document.documentURI){
                         GM_openInTab(uri);
                     }
                 }

                 if(tab.get_it) {
                     GM_xmlhttpRequest({  // Get it this way.(hopefully..)
                         method:'GET', url:el.href,
                         onload:function(result_obj){
                             if( tab.view_it ) {
                                 send('history/.collect.mirror',
                                      [el.href, result_obj.responseText],
                                      tab.view_it && on_get_success);
                             }
                         }})
                 } else{ if( tab.view_it ) {
                     on_get_success();
                 } }
             }
             finish_commandpanel();
        });
}

function cmd_vid() {  // Try open as video.
    ge('command_extend').textContent = "working...";

    var is = iface_state;

    var hover_uri = (is.hovered && find_a_href(is.hovered)) || is.hovered_href;
    if( (GM_getValue('cmd_vid_linklist') || "yes") != "yes" ) {
        cmd_vid_fun({href:hover_uri || document.documentURI});
    } else {  // NOTE the thing seems not very effective..
        // Get sorted list.  (closest links aren't good enough..)
        var list = []; //find_cursor_closest_links(false, hover_uri);

        list.unshift({ textContent:"cur page", href:document.documentURI });
        if(hover_uri){ list.unshift({ textContent:"hovered", href:hover_uri }); }

        ge('command_extend').innerHTML =
            "<span id='cmd_vid_say'></span><span id='cmd_vid_extend'></span>";
        produce_action_list(ge('cmd_vid_extend'), list, null, cmd_vid_fun, 'cmd_input');

        ge('command_input').onkeydown = function(ev) {
            if(ev.keyCode == 40){ ge('cmd_vid_0').focus(); }
        }
        ge('cmd_vid_0').focus();
    }
}
// -end
funs.vid = cmd_vid;

function cmd_fclip() {  // TODO cliboardData doesn't work?
    ge('command_extend').innerHTML = "working...";
    send('util/.fclip', [], function(result_obj){
        GM_setClipboard(JSON.decode(result_obj.responseText));
        finish_commandpanel();
    })
}
funs.fclip = cmd_fclip;

// Keydown listener.

(window.opera ? document.body : document).addEventListener('keydown', function(ev) {
    iface_state.x = ev.pageX;
    iface_state.y = ev.pageY;
    if( ev.ctrlKey && ev.keyCode == 59 ) { // Thats control-;.
        toggle_commandpanel(!ev.shiftKey);
    } else if( command_element && !command_element.hidden ){
        if( ev.keyCode == 27 ) { // Escape.
            ge('command_input').value = "";
            toggle_commandpanel();
            return;
        }
    }
    return false;
}, !window.opera);
